Loading...
Searching...
No Matches
AVBuffer
libavutil » Data Structures

AVBuffer is an API for reference-counted data buffers. More...

## Files

file | buffer.h
| refcounted data buffer API

## Data Structures

struct | AVBufferRef
| A reference to a data buffer. More...

## Macros

#define | AV_BUFFER_FLAG_READONLY (1 << 0)
| Always treat the buffer as read-only, even when it has only one reference.

## Typedefs

typedef struct AVBuffer | AVBuffer
| A reference counted buffer type.

## Functions

AVBufferRef * | av_buffer_alloc (size_t size)
| Allocate an AVBuffer of the given size using av_malloc().
AVBufferRef * | av_buffer_allocz (size_t size)
| Same as av_buffer_alloc(), except the returned buffer will be initialized to zero.
AVBufferRef * | av_buffer_create (uint8_t *data, size_t size, void(*free)(void *opaque, uint8_t *data), void *opaque, int flags)
| Create an AVBuffer from an existing array.
void | av_buffer_default_free (void *opaque, uint8_t *data)
| Default free callback, which calls av_free() on the buffer data.
AVBufferRef * | av_buffer_ref (const AVBufferRef *buf)
| Create a new reference to an AVBuffer.
void | av_buffer_unref (AVBufferRef **buf)
| Free a given reference and automatically free the buffer if there are no more references to it.
int | av_buffer_is_writable (const AVBufferRef *buf)
void * | av_buffer_get_opaque (const AVBufferRef *buf)
int | av_buffer_get_ref_count (const AVBufferRef *buf)
int | av_buffer_make_writable (AVBufferRef **buf)
| Create a writable reference from a given buffer reference, avoiding data copy if possible.
int | av_buffer_realloc (AVBufferRef **buf, size_t size)
| Reallocate a given buffer.
int | av_buffer_replace (AVBufferRef **dst, const AVBufferRef *src)
| Ensure dst refers to the same data as src.

## Detailed Description

AVBuffer is an API for reference-counted data buffers.

There are two core objects in this API – AVBuffer and AVBufferRef. AVBuffer represents the data buffer itself; it is opaque and not meant to be accessed by the caller directly, but only through AVBufferRef. However, the caller may e.g. compare two AVBuffer pointers to check whether two different references are describing the same data buffer. AVBufferRef represents a single reference to an AVBuffer and it is the object that may be manipulated by the caller directly.

There are two functions provided for creating a new AVBuffer with a single reference – av_buffer_alloc() to just allocate a new buffer, and av_buffer_create() to wrap an existing array in an AVBuffer. From an existing reference, additional references may be created with av_buffer_ref(). Use av_buffer_unref() to free a reference (this will automatically free the data once all the references are freed).

The convention throughout this API and the rest of FFmpeg is such that the buffer is considered writable if there exists only one reference to it (and it has not been marked as read-only). The av_buffer_is_writable() function is provided to check whether this is true and av_buffer_make_writable() will automatically create a new writable buffer when necessary. Of course nothing prevents the calling code from violating this convention, however that is safe only when all the existing references are under its control.

Note
  Referencing and unreferencing the buffers is thread-safe and thus may be done from multiple threads simultaneously without any need for additional locking.
  Two different references to the same buffer can point to different parts of the buffer (i.e. their AVBufferRef.data will not be equal).

## Macro Definition Documentation

## AV_BUFFER_FLAG_READONLY

#define AV_BUFFER_FLAG_READONLY (1 << 0)

Always treat the buffer as read-only, even when it has only one reference.

Definition at line 114 of file buffer.h.

## Typedef Documentation

## AVBuffer

typedef struct AVBuffer AVBuffer

A reference counted buffer type.

It is opaque and is meant to be used through references (AVBufferRef).

Definition at line 74 of file buffer.h.

## Function Documentation

## av_buffer_alloc()

AVBufferRef * av_buffer_alloc | ( | size_t | size | ) |

Allocate an AVBuffer of the given size using av_malloc().

Returns
  an AVBufferRef of given size or NULL when out of memory

## av_buffer_allocz()

AVBufferRef * av_buffer_allocz | ( | size_t | size | ) |

Same as av_buffer_alloc(), except the returned buffer will be initialized to zero.

## av_buffer_create()

AVBufferRef * av_buffer_create | ( | uint8_t * | data,
|  | size_t | size,
|  | void(* | free )(void *opaque, uint8_t *data),
|  | void * | opaque,
|  | int | flags )

Create an AVBuffer from an existing array.

If this function is successful, data is owned by the AVBuffer. The caller may only access data through the returned AVBufferRef and references derived from it. If this function fails, data is left untouched.

Parameters

  data | data array
  size | size of data in bytes
  free | a callback for freeing this buffer's data
  opaque | parameter to be got for processing or passed to free
  flags | a combination of AV_BUFFER_FLAG_*

Returns
  an AVBufferRef referring to data on success, NULL on failure.

## av_buffer_default_free()

void av_buffer_default_free | ( | void * | opaque,
|  | uint8_t * | data )

Default free callback, which calls av_free() on the buffer data.

This function is meant to be passed to av_buffer_create(), not called directly.

## av_buffer_ref()

AVBufferRef * av_buffer_ref | ( | const AVBufferRef * | buf | ) |

Create a new reference to an AVBuffer.

Returns
  a new AVBufferRef referring to the same AVBuffer as buf or NULL on failure.

Examples
  hw_decode.c, qsv_decode.c, qsv_transcode.c, vaapi_encode.c, and vaapi_transcode.c.

Referenced by dec_enc(), dec_enc(), hw_decoder_init(), main(), open_input_file(), open_input_file(), and set_hwframe_ctx().

## av_buffer_unref()

void av_buffer_unref | ( | AVBufferRef ** | buf | ) |

Free a given reference and automatically free the buffer if there are no more references to it.

Parameters

  buf | the reference to be freed. The pointer is set to NULL on return.

Examples
  hw_decode.c, qsv_decode.c, qsv_transcode.c, vaapi_encode.c, and vaapi_transcode.c.

Referenced by main(), main(), and set_hwframe_ctx().

## av_buffer_is_writable()

int av_buffer_is_writable | ( | const AVBufferRef * | buf | ) |

Returns
  1 if the caller may write to the data referred to by buf (which is true if and only if buf is the only reference to the underlying AVBuffer). Return 0 otherwise. A positive answer is valid until av_buffer_ref() is called on buf.

## av_buffer_get_opaque()

void * av_buffer_get_opaque | ( | const AVBufferRef * | buf | ) |

Returns
  the opaque parameter set by av_buffer_create.

## av_buffer_get_ref_count()

int av_buffer_get_ref_count | ( | const AVBufferRef * | buf | ) |

## av_buffer_make_writable()

int av_buffer_make_writable | ( | AVBufferRef ** | buf | ) |

Create a writable reference from a given buffer reference, avoiding data copy if possible.

Parameters

  buf | buffer reference to make writable. On success, buf is either left untouched, or it is unreferenced and a new writable AVBufferRef is written in its place. On failure, buf is left untouched.

Returns
  0 on success, a negative AVERROR on failure.

## av_buffer_realloc()

int av_buffer_realloc | ( | AVBufferRef ** | buf,
|  | size_t | size )

Reallocate a given buffer.

Parameters

  buf | a buffer reference to reallocate. On success, buf will be unreferenced and a new reference with the required size will be written in its place. On failure buf will be left untouched. *buf may be NULL, then a new buffer is allocated.
  size | required new buffer size.

Returns
  0 on success, a negative AVERROR on failure.

Note
  the buffer is actually reallocated with av_realloc() only if it was initially allocated through av_buffer_realloc(NULL) and there is only one reference to it (i.e. the one passed to this function). In all other cases a new buffer is allocated and the data is copied.

## av_buffer_replace()

int av_buffer_replace | ( | AVBufferRef ** | dst,
|  | const AVBufferRef * | src )

Ensure dst refers to the same data as src.

When *dst is already equivalent to src, do nothing. Otherwise unreference dst and replace it with a new reference to src.

Parameters

  dst | Pointer to either a valid buffer reference or NULL. On success, this will point to a buffer reference equivalent to src. On failure, dst will be left untouched.
  src | A buffer reference to replace dst with. May be NULL, then this function is equivalent to av_buffer_unref(dst).

Returns
  0 on success AVERROR(ENOMEM) on memory allocation failure.